unit uFilterPanel;

{$MODE objfpc}{$H+}

interface

uses
  Graphics, Classes, SysUtils, ExtCtrls, StdCtrls, Controls, Dialogs;

type

  { TFilterPanel }

  TFilterPanel = class(TPanel)
  private
    fLabelLeft, fLabelRight: TLabel;
    fFilterAuswahl: TComboBox;
    fFilterButton: TButton;
    fOnButtonClick: TNotifyEvent;
    fSuchbegriff: TEdit;
    procedure FilterButtonClick(Sender: TObject);
    function getfilterItems: TStrings;
    function getCaptionLeft: string;
    function getCaptionRight: string;
    function getFilterIndex: integer;
    function getSuchbegriff: string;
    function getCaptionButton: string;

    procedure setCaptionLeft(AValue: string);
    procedure setCaptionRight(AValue: string);
    procedure setFilterIndex(AValue: integer);
    procedure setFilteritems(AValue: TStrings);
    procedure setSuchbegriff(AValue: string);
    procedure setCaptionButton(Avalue: string);
  protected
    procedure DoFilterButtonClick; virtual;
  public
    constructor Create(TheOwner: TComponent); override;
  published
    property CaptionLeft: string read getCaptionLeft write setCaptionLeft;
    property CaptionRight: string read getCaptionRight write setCaptionRight;
    property FilterIndex: integer read getFilterIndex write SetFilterIndex;
    property Filteritems: TStrings read getFilterItems write setFilteritems;
    property Suchbegriff: string read getSuchbegriff write setSuchbegriff;
    property CaptionButton: string read getCaptionButton write setCaptionButton;
    property OnButtonClick: TNotifyEvent read fOnButtonClick write fOnButtonClick;

  end;

procedure Register();

implementation

procedure Register();
begin
  RegisterComponents('Additional', [TFilterPanel]);
end;

{ TFilterPanel }

function TFilterPanel.getCaptionLeft: string;
begin
  Result := fLabelLeft.Caption;
end;

procedure TFilterPanel.FilterButtonClick(Sender: TObject);
begin
  DoFilterButtonClick;
end;

function TFilterPanel.getfilterItems: TStrings;
begin
  Result := fFilterAuswahl.Items;
end;

function TFilterPanel.getCaptionRight: string;
begin
  Result := fLabelRight.Caption;
end;

function TFilterPanel.getFilterIndex: integer;
begin
  Result := fFilterAuswahl.ItemIndex;
end;

function TFilterPanel.getSuchbegriff: string;
begin
  Result := fSuchbegriff.Text;
end;

function TFilterPanel.getCaptionButton: string;
begin
  Result := fFilterButton.Caption;
end;

procedure TFilterPanel.setCaptionLeft(AValue: string);
begin
  fLabelLeft.Caption := AValue;
end;

procedure TFilterPanel.setCaptionRight(AValue: string);
begin
  fLabelRight.Caption := AValue;
end;

procedure TFilterPanel.setFilterIndex(AValue: integer);
begin
  fFilterAuswahl.ItemIndex := AValue;
end;

procedure TFilterPanel.setFilteritems(AValue: TStrings);
begin
  fFilterAuswahl.Items.AddStrings(AValue);
end;

procedure TFilterPanel.setSuchbegriff(AValue: string);
begin
  fSuchbegriff.Text := AValue;
end;

procedure TFilterPanel.setCaptionButton(Avalue: string);
begin
  fFilterButton.Caption := Avalue;
end;

procedure TFilterPanel.DoFilterButtonClick;
begin
  ShowMessage('Hallo');

  // Hier muss noch mehr rein

  if Assigned(fOnButtonClick) then
  begin
    // Fire user-assigned event handler
    fOnButtonClick(Self);
  end;
end;

constructor TFilterPanel.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);

  fLabelLeft := TLabel.Create(self);
  fLabelLeft.Name := 'LabelLeft';   // immer vor Parent !
  fLabelLeft.Parent := self;
  fLabelLeft.left := 6 + BevelWidth;
  fLabelLeft.Top := 6;

  fFilterauswahl := TComboBox.Create(self);
  fFilterAuswahl.Parent := self;
  fFilterAuswahl.AnchorToNeighbour(akLeft, 12, fLabelLeft);
  fFilterAuswahl.Width := 200;
  fFilterAuswahl.Top := 1;

  fSuchbegriff := TEdit.Create(self);
  fSuchbegriff.Name := 'Suchbegriff';
  fSuchbegriff.Parent := self;
  fSuchbegriff.AnchorToNeighbour(akLeft, 12, fFilterAuswahl);
  fSuchbegriff.Width := 200;
  fSuchbegriff.Top := 1;
  fSuchbegriff.Height := 29;

  fFilterButton := TButton.Create(self);
  fFilterButton.Name := 'Button';
  fFilterButton.Parent := self;
  fFilterButton.AnchorToNeighbour(akLeft, 12, fSuchbegriff);
  fFilterButton.Top := 1;
  fFilterButton.Height := 29;
  fFilterButton.OnClick := FilterButtonClick;

  fLabelRight := TLabel.Create(self);
  fLabelRight.Name := 'LabelRight';   // immer vor Parent !
  fLabelRight.Parent := self;
  fLabelRight.AnchorToNeighbour(akLeft, 12, fFilterButton);
  fLabelRight.Top := 6;
end;

end.

